## liburing 2.9

=== examples/Makefile ===
CPPFLAGS ?=
override CPPFLAGS += -D_GNU_SOURCE -I../src/include/
CFLAGS ?= -g -O2 -Wall
LDFLAGS ?=
override LDFLAGS += -L../src/ -luring

include ../Makefile.quiet

ifneq ($(MAKECMDGOALS),clean)
include ../config-host.mak
endif

LDFLAGS ?=
override LDFLAGS += -L../src/ -luring -lpthread

ifeq ($(CONFIG_USE_SANITIZER),y)
	override CFLAGS += -fsanitize=address,undefined -fno-omit-frame-pointer -fno-optimize-sibling-calls
	override CPPFLAGS += -fsanitize=address,undefined -fno-omit-frame-pointer -fno-optimize-sibling-calls
	override LDFLAGS += -fsanitize=address,undefined
endif

example_srcs := \
	io_uring-close-test.c \
	io_uring-cp.c \
	io_uring-test.c \
	io_uring-udp.c \
	link-cp.c \
	napi-busy-poll-client.c \
	napi-busy-poll-server.c \
	poll-bench.c \
	reg-wait.c \
	send-zerocopy.c \
	rsrc-update-bench.c \
	proxy.c \
	kdigest.c

all_targets :=


ifdef CONFIG_HAVE_UCONTEXT
	example_srcs += ucontext-cp.c
endif
all_targets += ucontext-cp helpers.o

example_targets := $(patsubst %.c,%,$(patsubst %.cc,%,$(example_srcs)))
all_targets += $(example_targets)

helpers = helpers.o

all: $(example_targets)

helpers.o: helpers.c
	$(QUIET_CC)$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ -c $<

%: %.c $(helpers) ../src/liburing.a
	$(QUIET_CC)$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ $< $(helpers) $(LDFLAGS)

clean:
	@rm -f $(all_targets)

.PHONY: all clean

=== src/Makefile ===
include ../Makefile.common

prefix ?= /usr
includedir ?= $(prefix)/include
libdir ?= $(prefix)/lib
libdevdir ?= $(prefix)/lib

LIBURING_CFLAGS ?=
CPPFLAGS ?=
override CPPFLAGS += -D_GNU_SOURCE \
	-Iinclude/ -include ../config-host.h \
	-D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
CFLAGS ?= -O3 -Wall -Wextra -fno-stack-protector
override CFLAGS += -Wno-unused-parameter \
	-DLIBURING_INTERNAL \
	$(LIBURING_CFLAGS)
SO_CFLAGS=-fPIC $(CFLAGS)
L_CFLAGS=$(CFLAGS)
ENABLE_SHARED ?= 1

soname=liburing.so.$(VERSION_MAJOR)
libname=liburing.so.$(VERSION)
ffi_soname=liburing-ffi.so.$(VERSION_MAJOR)
ffi_libname=liburing-ffi.so.$(VERSION)

all_targets += liburing.a
all_targets += liburing-ffi.a

ifeq ($(ENABLE_SHARED),1)
all_targets += $(libname)
all_targets += $(ffi_libname)
endif

include ../Makefile.quiet

ifneq ($(MAKECMDGOALS),clean)
include ../config-host.mak
endif

ifeq ($(CONFIG_USE_SANITIZER),y)
	LINK_FLAGS=
else
	LINK_FLAGS=-Wl,-z,defs
endif
LINK_FLAGS+=$(LDFLAGS)

all: $(all_targets)

liburing_srcs := setup.c queue.c register.c syscall.c version.c

ifeq ($(CONFIG_NOLIBC),y)
	liburing_srcs += nolibc.c
	override CFLAGS += -nostdlib -nodefaultlibs -ffreestanding -fno-builtin -fno-stack-protector
	override CPPFLAGS += -nostdlib -nodefaultlibs -ffreestanding -fno-builtin -fno-stack-protector
	override LINK_FLAGS += -nostdlib -nodefaultlibs $(libgcc_link_flag)
endif

ifeq ($(CONFIG_USE_SANITIZER),y)
	override CFLAGS += -fsanitize=address,undefined -g -fno-omit-frame-pointer -fno-optimize-sibling-calls
	override CPPFLAGS += -fsanitize=address,undefined -g -fno-omit-frame-pointer -fno-optimize-sibling-calls
	override LINK_FLAGS += -fsanitize=address,undefined
	liburing_srcs += sanitize.c
endif

override CPPFLAGS += -MT "$@" -MMD -MP -MF "$@.d"
liburing_objs := $(patsubst %.c,%.ol,$(liburing_srcs))
liburing_sobjs := $(patsubst %.c,%.os,$(liburing_srcs))
liburing_ffi_objs := ffi.ol
liburing_ffi_sobjs := ffi.os

%.os: %.c
	$(QUIET_CC)$(CC) $(CPPFLAGS) $(SO_CFLAGS) -c -o $@ $<

%.ol: %.c
	$(QUIET_CC)$(CC) $(CPPFLAGS) $(L_CFLAGS) -c -o $@ $<

# Include compiler generated dependency files.
-include $(liburing_objs:%=%.d)
-include $(liburing_sobjs:%=%.d)

AR ?= ar
RANLIB ?= ranlib
liburing.a: $(liburing_objs)
	@rm -f liburing.a
	$(QUIET_AR)$(AR) r liburing.a $^
	$(QUIET_RANLIB)$(RANLIB) liburing.a

liburing-ffi.a: $(liburing_objs) $(liburing_ffi_objs)
	@rm -f liburing-ffi.a
	$(QUIET_AR)$(AR) r liburing-ffi.a $^
	$(QUIET_RANLIB)$(RANLIB) liburing-ffi.a

$(libname): $(liburing_sobjs) liburing.map
	$(QUIET_CC)$(CC) $(SO_CFLAGS) -shared -Wl,--version-script=liburing.map -Wl,-soname=$(soname) -o $@ $(liburing_sobjs) $(LINK_FLAGS)

$(ffi_libname): $(liburing_ffi_objs) $(liburing_ffi_sobjs) $(liburing_sobjs) liburing-ffi.map
	$(QUIET_CC)$(CC) $(SO_CFLAGS) -shared -Wl,--version-script=liburing-ffi.map -Wl,-soname=$(ffi_soname) -o $@ $(liburing_sobjs) $(liburing_ffi_sobjs) $(LINK_FLAGS)

install: $(all_targets)
	install -D -m 644 include/liburing/io_uring.h $(includedir)/liburing/io_uring.h
	install -D -m 644 include/liburing.h $(includedir)/liburing.h
	install -D -m 644 include/liburing/compat.h $(includedir)/liburing/compat.h
	install -D -m 644 include/liburing/barrier.h $(includedir)/liburing/barrier.h
	install -D -m 644 include/liburing/sanitize.h $(includedir)/liburing/sanitize.h
	install -D -m 644 include/liburing/io_uring_version.h $(includedir)/liburing/io_uring_version.h
	install -D -m 644 liburing.a $(libdevdir)/liburing.a
	install -D -m 644 liburing-ffi.a $(libdevdir)/liburing-ffi.a
ifeq ($(ENABLE_SHARED),1)
	install -D -m 755 $(libname) $(libdir)/$(libname)
	install -D -m 755 $(ffi_libname) $(libdir)/$(ffi_libname)
	ln -sf $(libname) $(libdir)/$(soname)
	ln -sf $(relativelibdir)$(libname) $(libdevdir)/liburing.so
	ln -sf $(ffi_libname) $(libdir)/$(ffi_soname)
	ln -sf $(relativelibdir)$(ffi_libname) $(libdevdir)/liburing-ffi.so
endif

uninstall:
	@rm -f $(includedir)/liburing/io_uring.h
	@rm -f $(includedir)/liburing.h
	@rm -f $(includedir)/liburing/compat.h
	@rm -f $(includedir)/liburing/barrier.h
	@rm -f $(includedir)/liburing/sanitize.h
	@rm -f $(includedir)/liburing/io_uring_version.h
	@rm -f $(libdevdir)/liburing.a
	@rm -f $(libdevdir)/liburing-ffi.a
ifeq ($(ENABLE_SHARED),1)
	@rm -f $(libdir)/$(libname)
	@rm -f $(libdir)/$(ffi_libname)
	@rm -f $(libdir)/$(soname)
	@rm -f $(libdevdir)/liburing.so
	@rm -f $(libdir)/$(ffi_soname)
	@rm -f $(libdevdir)/liburing-ffi.so
endif

clean:
	@rm -f $(all_targets) $(liburing_objs) $(liburing_sobjs) $(liburing_ffi_objs) $(liburing_ffi_sobjs) $(soname).new
	@rm -f *.so* *.a *.o *.d
	@rm -f include/liburing/compat.h
	@rm -f include/liburing/io_uring_version.h

	@# When cleaning, we don't include ../config-host.mak,
	@# so the nolibc objects are always skipped, clean them up!
	@rm -f nolibc.ol nolibc.os

=== test/Makefile ===
prefix ?= /usr
datadir ?= $(prefix)/share

INSTALL=install

ifneq ($(MAKECMDGOALS),clean)
include ../config-host.mak
endif

CPPFLAGS ?=

override CPPFLAGS += \
	-D_GNU_SOURCE \
	-D__SANE_USERSPACE_TYPES__ \
	-I../src/include/ \
	-include ../config-host.h \
	-D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64

CFLAGS ?= -g -O3 -Wall -Wextra
XCFLAGS = -Wno-unused-parameter -Wno-sign-compare

ifdef CONFIG_HAVE_STRINGOP_OVERFLOW
	XCFLAGS += -Wstringop-overflow=0
endif

ifdef CONFIG_HAVE_ARRAY_BOUNDS
	XCFLAGS += -Warray-bounds=0
endif

ifeq ($(CONFIG_USE_SANITIZER),y)
	XCFLAGS += -fsanitize=address,undefined -fno-omit-frame-pointer -fno-optimize-sibling-calls
endif

CXXFLAGS ?= $(CFLAGS)
override CFLAGS += $(XCFLAGS) -DLIBURING_BUILD_TEST
override CXXFLAGS += $(XCFLAGS) -std=c++11 -DLIBURING_BUILD_TEST

LDFLAGS ?=
override LDFLAGS += -L../src/ -luring -lpthread

# Please keep this list sorted alphabetically.
test_srcs := \
	232c93d07b74.c \
	35fa71a030ca.c \
	500f9fbadef8.c \
	7ad0e4b2f83c.c \
	8a9973408177.c \
	917257daa0fe.c \
	a0908ae19763.c \
	a4c0b3decb33.c \
	accept.c \
	accept-link.c \
	accept-non-empty.c \
	accept-reuse.c \
	accept-test.c \
	across-fork.c \
	b19062a56726.c \
	b5837bd5311d.c \
	bind-listen.c \
	buf-ring.c \
	buf-ring-nommap.c \
	buf-ring-put.c \
	ce593a6c480a.c \
	close-opath.c \
	connect.c \
	connect-rep.c \
	coredump.c \
	cmd-discard.c \
	cq-full.c \
	cq-overflow.c \
	cq-peek-batch.c \
	cq-ready.c \
	cq-size.c \
	d4ae271dfaae.c \
	d77a67ed5f27.c \
	defer.c \
	defer-taskrun.c \
	defer-tw-timeout.c \
	double-poll-crash.c \
	drop-submit.c \
	eeed8b54e0df.c \
	empty-eownerdead.c \
	eploop.c \
	eventfd.c \
	eventfd-disable.c \
	eventfd-reg.c \
	eventfd-ring.c \
	evloop.c \
	exec-target.c \
	exit-no-cleanup.c \
	fadvise.c \
	fallocate.c \
	fc2a85cb02ef.c \
	fd-install.c \
	fd-pass.c \
	fdinfo.c \
	fifo-nonblock-read.c \
	file-exit-unreg.c \
	file-register.c \
	files-exit-hang-poll.c \
	files-exit-hang-timeout.c \
	file-update.c \
	file-verify.c \
	fixed-buf-iter.c \
	fixed-buf-merge.c \
	fixed-hugepage.c \
	fixed-link.c \
	fixed-reuse.c \
	fpos.c \
	fsnotify.c \
	fsync.c \
	futex.c \
	hardlink.c \
	ignore-single-mmap.c \
	init-mem.c \
	io-cancel.c \
	iopoll.c \
	iopoll-leak.c \
	iopoll-overflow.c \
	io_uring_enter.c \
	io_uring_passthrough.c \
	io_uring_register.c \
	io_uring_setup.c \
	kallsyms.c \
	lfs-openat.c \
	lfs-openat-write.c \
	link.c \
	link_drain.c \
	link-timeout.c \
	linked-defer-close.c \
	madvise.c \
	min-timeout.c \
	min-timeout-wait.c \
	mkdir.c \
	msg-ring.c \
	msg-ring-fd.c \
	msg-ring-flags.c \
	msg-ring-overflow.c \
	multicqes_drain.c \
	napi-test.c \
	no-mmap-inval.c \
	nop-all-sizes.c \
	nop.c \
	ooo-file-unreg.c \
	openat2.c \
	open-close.c \
	open-direct-link.c \
	open-direct-pick.c \
	personality.c \
	pipe-bug.c \
	pipe-eof.c \
	pipe-reuse.c \
	poll.c \
	poll-cancel.c \
	poll-cancel-all.c \
	poll-cancel-ton.c \
	poll-link.c \
	poll-many.c \
	poll-mshot-overflow.c \
	poll-mshot-update.c \
	poll-race.c \
	poll-race-mshot.c \
	poll-ring.c \
	poll-v-poll.c \
	pollfree.c \
	probe.c \
	read-before-exit.c \
	read-inc-file.c \
	read-mshot.c \
	read-mshot-empty.c \
	read-mshot-stdin.c \
	read-write.c \
	recv-msgall.c \
	recv-msgall-stream.c \
	recv-multishot.c \
	reg-fd-only.c \
	reg-hint.c \
	reg-reg-ring.c \
	reg-wait.c \
	regbuf-clone.c \
	regbuf-merge.c \
	register-restrictions.c \
	rename.c \
	resize-rings.c \
	ringbuf-read.c \
	ringbuf-status.c \
	ring-leak2.c \
	ring-leak.c \
	rsrc_tags.c \
	rw_merge_test.c \
	self.c \
	recvsend_bundle.c \
	recvsend_bundle-inc.c \
	send_recv.c \
	send_recvmsg.c \
	send-zerocopy.c \
	shared-wq.c \
	short-read.c \
	shutdown.c \
	sigfd-deadlock.c \
	single-issuer.c \
	skip-cqe.c \
	socket.c \
	socket-io-cmd.c \
	socket-getsetsock-cmd.c \
	socket-nb.c \
	socket-rw.c \
	socket-rw-eagain.c \
	socket-rw-offset.c \
	splice.c \
	sq-full.c \
	sq-full-cpp.cc \
	sqpoll-disable-exit.c \
	sqpoll-exec.c \
	sq-poll-dup.c \
	sqpoll-exit-hang.c \
	sq-poll-kthread.c \
	sq-poll-share.c \
	sqpoll-sleep.c \
	sq-space_left.c \
	sqwait.c \
	stdout.c \
	submit-and-wait.c \
	submit-link-fail.c \
	submit-reuse.c \
	symlink.c \
	sync-cancel.c \
	teardowns.c \
	thread-exit.c \
	timeout.c \
	timeout-new.c \
	truncate.c \
	tty-write-dpoll.c \
	unlink.c \
	uring_cmd_ublk.c \
	version.c \
	waitid.c \
	wait-timeout.c \
	wakeup-hang.c \
	wq-aff.c \
	xattr.c \
	# EOL

# Please keep this list sorted alphabetically.
asan_test_srcs := \
	xfail_prep_link_timeout_out_of_scope.c \
	xfail_register_buffers_out_of_scope.c \
	# EOL

all_targets :=
include ../Makefile.quiet

ifeq ($(CONFIG_NOLIBC),y)
	test_srcs += nolibc.c
endif

ifdef CONFIG_HAVE_STATX
	test_srcs += statx.c
else ifdef CONFIG_HAVE_GLIBC_STATX
	test_srcs += statx.c
endif
all_targets += statx.t

ifdef CONFIG_HAVE_CXX
	test_srcs += sq-full-cpp.cc
endif
all_targets += sq-full-cpp.t


test_targets := $(patsubst %.c,%,$(test_srcs))
test_targets := $(patsubst %.cc,%,$(test_targets))
run_test_targets := $(patsubst %,%.run_test,$(test_targets))
test_targets := $(patsubst %,%.t,$(test_targets))
all_targets += $(test_targets)
helpers = helpers.o

ifeq ($(CONFIG_USE_SANITIZER),y)
	asan_test_targets := $(patsubst %.c,%,$(asan_test_srcs))
	asan_test_targets := $(patsubst %.cc,%,$(asan_test_targets))
	asan_run_test_targets := $(patsubst %,%.run_test,$(asan_test_targets))
	asan_test_targets := $(patsubst %,%.t,$(asan_test_targets))
	all_targets += $(asan_test_targets)
endif

all: $(test_targets) $(asan_test_targets)

helpers.o: helpers.c
	$(QUIET_CC)$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ -c $<

LIBURING := $(shell if [ -e ../src/liburing.a ]; then echo ../src/liburing.a; fi)

%.t: %.c $(helpers) helpers.h $(LIBURING)
	$(QUIET_CC)$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ $< $(helpers) $(LDFLAGS)

#
# Clang++ is not happy with -Wmissing-prototypes:
#
#   cc1plus: warning: command-line option '-Wmissing-prototypes' \
#   is valid for C/ObjC but not for C++
#
%.t: %.cc $(helpers) helpers.h $(LIBURING)
	$(QUIET_CXX)$(CXX) \
	$(patsubst -Wmissing-prototypes,,$(CPPFLAGS)) \
	$(patsubst -Wmissing-prototypes,,$(CXXFLAGS)) \
	-o $@ $< $(helpers) $(LDFLAGS)


install: $(test_targets) runtests.sh runtests-loop.sh
	$(INSTALL) -D -d -m 755 $(datadir)/liburing-test/
	$(INSTALL) -D -m 755 $(test_targets) $(datadir)/liburing-test/
	$(INSTALL) -D -m 755 runtests.sh  $(datadir)/liburing-test/
	$(INSTALL) -D -m 755 runtests-loop.sh  $(datadir)/liburing-test/

uninstall:
	@rm -rf $(datadir)/liburing-test/

clean:
	@rm -f $(all_targets) helpers.o output/*
	@rm -rf output/

runtests: all
	@./runtests.sh $(test_targets) $(asan_test_targets)

runtests-loop: all
	@./runtests-loop.sh $(test_targets) $(asan_test_targets)

%.run_test: %.t
	@./runtests-quiet.sh $<

runtests-parallel: $(run_test_targets)
	@echo "All tests passed"

.PHONY: all install clean runtests runtests-loop runtests-parallel

=== debian/changelog ===
liburing (2.9-1) unstable; urgency=medium

  * New upstream release.

 -- Guillem Jover <guillem@debian.org>  Wed, 05 Feb 2025 12:13:49 +0100

=== debian/control ===
Source: liburing
Section: libs
Priority: optional
Maintainer: Guillem Jover <guillem@debian.org>
Vcs-Browser: https://git.hadrons.org/cgit/debian/pkgs/liburing.git
Vcs-Git: https://git.hadrons.org/git/debian/pkgs/liburing.git
Homepage: https://github.com/axboe/liburing
Standards-Version: 4.7.0
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 debhelper (>= 13.10),
 dpkg-dev (>= 1.22.0),
 procps <!nocheck>,

Package: liburing2
Architecture: linux-any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Linux kernel io_uring access library - shared library
 This library provides helpers to setup and teardown io_uring instances,
 and also a simplified interface for applications that do not need (or
 want) to deal with the full kernel side implementation.
 .
 This package contains the shared library.

Package: liburing-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends:
 ${misc:Depends},
 liburing2 (= ${binary:Version}),
 libc6-dev | libc-dev,
 linux-libc-dev (>= 5.1),
Description: Linux kernel io_uring access library - development files
 This library provides helpers to setup and teardown io_uring instances,
 and also a simplified interface for applications that do not need (or
 want) to deal with the full kernel side implementation.
 .
 This package contains the static library and the header files.

## liburing 2.11

=== debian/changelog ===
liburing (2.11-1) unstable; urgency=medium

  * New upstream release.
  * Remove «Rules-Requires-Root: no», which is the current default.
  * Remove «Priority: optional» field, which is the current default.
  * Switch to Standards-Version 4.7.2 (no changes needed).

 -- Guillem Jover <guillem@debian.org>  Mon, 11 Aug 2025 01:12:17 +0200

## liburing 2.12

=== test/Makefile ===
--- 
+++ 
@@ -62,6 +62,7 @@
 	buf-ring-put.c \
 	ce593a6c480a.c \
 	close-opath.c \
+	conn-unreach.c \
 	connect.c \
 	connect-rep.c \
 	coredump.c \
@@ -81,10 +82,12 @@
 	eeed8b54e0df.c \
 	empty-eownerdead.c \
 	eploop.c \
+	epwait.c \
 	eventfd.c \
 	eventfd-disable.c \
 	eventfd-reg.c \
 	eventfd-ring.c \
+	evfd-short-read.c \
 	evloop.c \
 	exec-target.c \
 	exit-no-cleanup.c \
@@ -94,6 +97,7 @@
 	fd-install.c \
 	fd-pass.c \
 	fdinfo.c \
+	fdinfo-sqpoll.c \
 	fifo-nonblock-read.c \
 	file-exit-unreg.c \
 	file-register.c \
@@ -106,10 +110,12 @@
 	fixed-hugepage.c \
 	fixed-link.c \
 	fixed-reuse.c \
+	fixed-seg.c \
 	fpos.c \
 	fsnotify.c \
 	fsync.c \
 	futex.c \
+	futex-kill.c \
 	hardlink.c \
 	ignore-single-mmap.c \
 	init-mem.c \
@@ -121,6 +127,7 @@
 	io_uring_passthrough.c \
 	io_uring_register.c \
 	io_uring_setup.c \
+	iowait.c \
 	kallsyms.c \
 	lfs-openat.c \
 	lfs-openat-write.c \
@@ -147,6 +154,7 @@
 	open-direct-link.c \
 	open-direct-pick.c \
 	personality.c \
+	pipe.c \
 	pipe-bug.c \
 	pipe-eof.c \
 	pipe-reuse.c \
@@ -170,8 +178,11 @@
 	read-mshot-empty.c \
 	read-mshot-stdin.c \
 	read-write.c \
+	recv-bundle-short-ooo.c \
+	recv-inc-ooo.c \
 	recv-msgall.c \
 	recv-msgall-stream.c \
+	recv-mshot-fair.c \
 	recv-multishot.c \
 	reg-fd-only.c \
 	reg-hint.c \
@@ -194,6 +205,7 @@
 	send_recv.c \
 	send_recvmsg.c \
 	send-zerocopy.c \
+	sendmsg_iov_clean.c \
 	shared-wq.c \
 	short-read.c \
 	shutdown.c \
@@ -227,6 +239,7 @@
 	sync-cancel.c \
 	teardowns.c \
 	thread-exit.c \
+	timerfd-short-read.c \
 	timeout.c \
 	timeout-new.c \
 	truncate.c \
@@ -239,6 +252,9 @@
 	wakeup-hang.c \
 	wq-aff.c \
 	xattr.c \
+	zcrx.c \
+	vec-regbuf.c \
+	timestamp.c \
 	# EOL
 
 # Please keep this list sorted alphabetically.

=== debian/changelog ===
liburing (2.12-1) unstable; urgency=medium

  * New upstream release.
  * Switch to debian/watch version 5.

 -- Guillem Jover <guillem@debian.org>  Thu, 04 Sep 2025 11:32:53 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,10 @@
 Source: liburing
 Section: libs
-Priority: optional
 Maintainer: Guillem Jover <guillem@debian.org>
 Vcs-Browser: https://git.hadrons.org/cgit/debian/pkgs/liburing.git
 Vcs-Git: https://git.hadrons.org/git/debian/pkgs/liburing.git
 Homepage: https://github.com/axboe/liburing
-Standards-Version: 4.7.0
-Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Build-Depends:
  debhelper-compat (= 13),
  debhelper (>= 13.10),

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all abi=+lfs
export DEB_CFLAGS_MAINT_PREPEND = -Wall

DPKG_EXPORT_BUILDTOOLS = 1
include /usr/share/dpkg/buildtools.mk

buildflags =
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
	buildflags += V=1
endif
buildflags += CPPFLAGS="$(CPPFLAGS)"
buildflags += CFLAGS="$(CFLAGS)"
buildflags += LDFLAGS="$(LDFLAGS)"

%:
	dh $@

override_dh_auto_configure:
	./configure \
	  --prefix=/usr \
	  --includedir=/usr/include \
	  --datadir=/usr/share \
	  --mandir=/usr/share/man \
	  --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	  --libdevdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	  --use-libc \
	  --cc=$(CC)

override_dh_auto_build:
	dh_auto_build -- $(buildflags)

# XXX: The tests do not pass yet as of Linux 6.5, and they are not being
# skipped either.
override_dh_auto_test:
	dh_auto_test -- runtests || true

override_dh_installchangelogs:
	dh_installchangelogs --no-trim

=== debian/watch ===
Version: 5

Source: https://brick.kernel.dk/snaps/
Matching-Pattern: liburing-([\d\.]+)\.tar\.[gx]z
Pgp-Sig-Url-Mangle: s/$/.asc/

## liburing 2.13

=== test/Makefile ===
--- 
+++ 
@@ -29,6 +29,10 @@
 
 ifeq ($(CONFIG_USE_SANITIZER),y)
 	XCFLAGS += -fsanitize=address,undefined -fno-omit-frame-pointer -fno-optimize-sibling-calls
+endif
+
+ifeq ($(CONFIG_USE_TSAN),y)
+	XCFLAGS += -fsanitize=thread -fno-omit-frame-pointer -fno-optimize-sibling-calls
 endif
 
 CXXFLAGS ?= $(CFLAGS)
@@ -99,6 +103,7 @@
 	fdinfo.c \
 	fdinfo-sqpoll.c \
 	fifo-nonblock-read.c \
+	fifo-futex-poll.c \
 	file-exit-unreg.c \
 	file-register.c \
 	files-exit-hang-poll.c \
@@ -148,6 +153,8 @@
 	no-mmap-inval.c \
 	nop-all-sizes.c \
 	nop.c \
+	nop32.c \
+	nop32-overflow.c \
 	ooo-file-unreg.c \
 	openat2.c \
 	open-close.c \
@@ -193,6 +200,7 @@
 	register-restrictions.c \
 	rename.c \
 	resize-rings.c \
+	ringbuf-loop.c \
 	ringbuf-read.c \
 	ringbuf-status.c \
 	ring-leak2.c \
@@ -221,7 +229,6 @@
 	socket-rw-offset.c \
 	splice.c \
 	sq-full.c \
-	sq-full-cpp.cc \
 	sqpoll-disable-exit.c \
 	sqpoll-exec.c \
 	sq-poll-dup.c \
@@ -230,6 +237,9 @@
 	sq-poll-share.c \
 	sqpoll-sleep.c \
 	sq-space_left.c \
+	sqe-mixed-nop.c \
+	sqe-mixed-bad-wrap.c \
+	sqe-mixed-uring_cmd.c \
 	sqwait.c \
 	stdout.c \
 	submit-and-wait.c \
@@ -255,6 +265,8 @@
 	zcrx.c \
 	vec-regbuf.c \
 	timestamp.c \
+	ring-query.c \
+	mock_file.c \
 	# EOL
 
 # Please keep this list sorted alphabetically.

=== debian/changelog ===
liburing (2.13-1) unstable; urgency=medium

  * New upstream release.
  * Set «Update-Script: uupdate» in debian/watch.
  * Use spaces around assignment operator in make variable to distinguish
    them from shell assignments.

 -- Guillem Jover <guillem@debian.org>  Sat, 20 Dec 2025 03:52:19 +0100

=== debian/watch ===
Version: 5

Source: https://brick.kernel.dk/snaps/
Matching-Pattern: liburing-([\d\.]+)\.tar\.[gx]z
Pgp-Sig-Url-Mangle: s/$/.asc/
Update-Script: uupdate

## liburing 2.14

=== src/Makefile ===
--- 
+++ 
@@ -13,6 +13,7 @@
 CFLAGS ?= -O3 -Wall -Wextra -fno-stack-protector
 override CFLAGS += -Wno-unused-parameter \
 	-DLIBURING_INTERNAL \
+	$(BUILD_CFLAGS) \
 	$(LIBURING_CFLAGS)
 SO_CFLAGS=-fPIC $(CFLAGS)
 L_CFLAGS=$(CFLAGS)
@@ -62,6 +63,12 @@
 	liburing_srcs += sanitize.c
 endif
 
+ifeq ($(CONFIG_USE_TSAN),y)
+	override CFLAGS += -fsanitize=thread -fno-omit-frame-pointer -fno-optimize-sibling-calls
+	override CPPFLAGS += -fsanitize=thread -fno-omit-frame-pointer -fno-optimize-sibling-calls
+	override LINK_FLAGS += -fsanitize=thread -ltsan
+endif
+
 override CPPFLAGS += -MT "$@" -MMD -MP -MF "$@.d"
 liburing_objs := $(patsubst %.c,%.ol,$(liburing_srcs))
 liburing_sobjs := $(patsubst %.c,%.os,$(liburing_srcs))
@@ -74,9 +81,7 @@
 %.ol: %.c
 	$(QUIET_CC)$(CC) $(CPPFLAGS) $(L_CFLAGS) -c -o $@ $<
 
-# Include compiler generated dependency files.
--include $(liburing_objs:%=%.d)
--include $(liburing_sobjs:%=%.d)
+-include $(liburing_objs:%=%.d) $(liburing_sobjs:%=%.d) $(liburing_ffi_objs:%=%.d) $(liburing_ffi_sobjs:%=%.d)
 
 AR ?= ar
 RANLIB ?= ranlib
@@ -101,8 +106,8 @@
 	install -D -m 644 include/liburing.h $(includedir)/liburing.h
 	install -D -m 644 include/liburing/compat.h $(includedir)/liburing/compat.h
 	install -D -m 644 include/liburing/barrier.h $(includedir)/liburing/barrier.h
-	install -D -m 644 include/liburing/sanitize.h $(includedir)/liburing/sanitize.h
 	install -D -m 644 include/liburing/io_uring_version.h $(includedir)/liburing/io_uring_version.h
+	install -D -m 644 include/liburing/io_uring/query.h $(includedir)/liburing/io_uring/query.h
 	install -D -m 644 liburing.a $(libdevdir)/liburing.a
 	install -D -m 644 liburing-ffi.a $(libdevdir)/liburing-ffi.a
 ifeq ($(ENABLE_SHARED),1)
@@ -121,6 +126,7 @@
 	@rm -f $(includedir)/liburing/barrier.h
 	@rm -f $(includedir)/liburing/sanitize.h
 	@rm -f $(includedir)/liburing/io_uring_version.h
+	@rm -f $(includedir)/liburing/io_uring/query.h
 	@rm -f $(libdevdir)/liburing.a
 	@rm -f $(libdevdir)/liburing-ffi.a
 ifeq ($(ENABLE_SHARED),1)

=== test/Makefile ===
--- 
+++ 
@@ -132,6 +132,8 @@
 	io_uring_passthrough.c \
 	io_uring_register.c \
 	io_uring_setup.c \
+	io-wq-exit.c \
+	io-wq-unused-exit.c \
 	iowait.c \
 	kallsyms.c \
 	lfs-openat.c \
@@ -144,6 +146,7 @@
 	min-timeout.c \
 	min-timeout-wait.c \
 	mkdir.c \
+	mock_file.c \
 	msg-ring.c \
 	msg-ring-fd.c \
 	msg-ring-flags.c \
@@ -176,6 +179,7 @@
 	poll-race.c \
 	poll-race-mshot.c \
 	poll-ring.c \
+	poll-update-trigger.c \
 	poll-v-poll.c \
 	pollfree.c \
 	probe.c \
@@ -205,6 +209,7 @@
 	ringbuf-status.c \
 	ring-leak2.c \
 	ring-leak.c \
+	ring-query.c \
 	rsrc_tags.c \
 	rw_merge_test.c \
 	self.c \
@@ -214,6 +219,7 @@
 	send_recvmsg.c \
 	send-zerocopy.c \
 	sendmsg_iov_clean.c \
+	sendzc-bug.c \
 	shared-wq.c \
 	short-read.c \
 	shutdown.c \
@@ -252,10 +258,13 @@
 	timerfd-short-read.c \
 	timeout.c \
 	timeout-new.c \
+	timestamp.c \
+	timestamp-bug.c \
 	truncate.c \
 	tty-write-dpoll.c \
 	unlink.c \
 	uring_cmd_ublk.c \
+	vec-regbuf.c \
 	version.c \
 	waitid.c \
 	wait-timeout.c \
@@ -263,10 +272,6 @@
 	wq-aff.c \
 	xattr.c \
 	zcrx.c \
-	vec-regbuf.c \
-	timestamp.c \
-	ring-query.c \
-	mock_file.c \
 	# EOL
 
 # Please keep this list sorted alphabetically.

=== debian/changelog ===
liburing (2.14-1) unstable; urgency=medium

  * New upstream release.
  * Switch to Standards-Version 4.7.3 (no changes needed).

 -- Guillem Jover <guillem@debian.org>  Thu, 12 Feb 2026 23:57:06 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Vcs-Browser: https://git.hadrons.org/cgit/debian/pkgs/liburing.git
 Vcs-Git: https://git.hadrons.org/git/debian/pkgs/liburing.git
 Homepage: https://github.com/axboe/liburing
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Build-Depends:
  debhelper-compat (= 13),
  debhelper (>= 13.10),

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 
 # Uncomment this to turn on verbose mode.
-#export DH_VERBOSE=1
+#export DH_VERBOSE = 1
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all abi=+lfs
 export DEB_CFLAGS_MAINT_PREPEND = -Wall
